var j5 = require("johnny-five"),
    board = new j5.Board();

board.on("ready", function () {
    var ping, button, lights, ginches, lowerLimit, offset;

    ping = new j5.Ping({
        pin: 8,
        freq: 250
    });

    button = new j5.Button({
        pin: 7,
        holdtime: 500,
        invert: true
    });

    [
        { color: "red", pin: 3 },
        { color: "yellow", pin: 2 },
        { color: "green", pin: 4 }
    ].forEach(function(light) {
        lights[light.color] = new j5.Led(light.pin);
    });

    // Create a reference to all of the initialized Leds
    lights.all = new Leds();

    ginches = 20;

    button.on("hold", function () {
        offset = ginches;
        console.log("offset = " + offset);
    });

    lowerLimit = 2;
    offset = 5;

    ping.on("change", function (err, value) {
        ginches = this.inches;

        lights.all.off();

        // flashing red
        if (this.inches < (lowerLimit + offset)) {
            console.log("flashing red");
            lights.red.strobe(200);
            lights.yellow.off();
            lights.green.off();
            //goto end
        }
            // solid red
        else if (this.inches > lowerLimit + offset && this.inches < 6 + offset) {
            console.log("red");
            lights.red.off().stop();
            lights.red.on();
            lights.yellow.off();
            lights.green.off();
        }
            // red and yellow
        else if (this.inches > 6 + offset && this.inches < 10 + offset) {
            console.log("red and yellow");
            lights.red.off().stop();
            lights.red.on();
            lights.yellow.on();
            lights.green.off();
        }
            // yellow
        else if (this.inches > 10 + offset && this.inches < 20 + offset) {
            console.log("yellow");
            lights.red.off();
            lights.yellow.on();
            lights.green.off();
        }
            // green and yellow
        else if (this.inches > 20 + offset && this.inches < 35 + offset) {
            console.log("green and yellow");
            lights.green.on();
            lights.yellow.on();
            lights.red.off();
        }
            // green
            // if (this.inches > 35 + offset) {
        else if (this.inches > 55 + offset) {
            console.log("green");
            lights.red.off();
            lights.yellow.off();
            lights.green.on();
        }

        // green

        // off
        //    lights.red.off();
        //    lights.yellow.off();
        //    lights.green.off();

        //end:

        //console.log(typeof this.inches);
        //console.log("Object is " + this.inches + "inches away");
    });

    initTrafficLights();

    this.repl.inject({
        lights.red: lights.red
    });

    console.log("You can interact with the RGB LED via the variable 'led' e.g. led.on();\n Hit control-D to exit.\n >> ");
    console.log('try "on", "off", "toggle", "strobe", "stop" (stops strobing)');

});
